package main

import (
	"context"
	"go-rest-api/server"
	"log"
	"os"
	"os/signal"
	"time"
)

func main() {
	s := server.NewServer(":8000")

	go func() {
		s.Serve()
	}()

	signCh := make(chan os.Signal)
	signal.Notify(signCh, os.Interrupt)
	signal.Notify(signCh, os.Kill)

	sig := <-signCh
	log.Println("Received terminal, graceful shutdown", sig)

	tc, _ := context.WithTimeout(context.Background(), 30*time.Second)
	s.Shutdown(tc)
}
